// -*- C++ -*-
// $Id$

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.2a_p14
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// be/be_codegen.cpp:152

#ifndef _TAO_IDL_DDSDCPSGUIDC_LISGUH_H_
#define _TAO_IDL_DDSDCPSGUIDC_LISGUH_H_

#include /**/ "ace/pre.h"


#include /**/ "ace/config-all.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */


#include /**/ "dds/DCPS/dcps_export.h"
#include "tao/ORB.h"
#include "tao/Basic_Types.h"
#include "tao/Sequence_T.h"
#include "tao/Seq_Var_T.h"
#include "tao/Seq_Out_T.h"
#include "tao/VarOut_T.h"
#include "tao/Array_VarOut_T.h"
#include "tao/Arg_Traits_T.h"
#include "tao/Basic_Arguments.h"
#include "tao/Special_Basic_Arguments.h"
#include "tao/Any_Insert_Policy_T.h"
#include "tao/Fixed_Size_Argument_T.h"
#include "tao/Var_Size_Argument_T.h"
#include "tao/Fixed_Array_Argument_T.h"
#include "tao/Var_Array_Argument_T.h"
#include /**/ "tao/Version.h"
#include /**/ "tao/Versioned_Namespace.h"
#include /**/ "dds/Versioned_Namespace.h"

#if TAO_MAJOR_VERSION != 2 || TAO_MINOR_VERSION != 2 || TAO_BETA_VERSION != 0
#error This file should be regenerated with TAO_IDL
#endif

#if defined (TAO_EXPORT_MACRO)
#undef TAO_EXPORT_MACRO
#endif
#define TAO_EXPORT_MACRO OpenDDS_Dcps_Export

OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace OpenDDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:38

  namespace DCPS
  {

    // TAO_IDL - Generated from
    // be/be_visitor_array/array_ch.cpp:54

    typedef ::CORBA::Octet GuidVendorId_t[2];
    typedef ::CORBA::Octet GuidVendorId_t_slice;
    struct GuidVendorId_t_tag {};
    

    typedef
      TAO_FixedArray_Var_T<
          GuidVendorId_t,
          GuidVendorId_t_slice,
          GuidVendorId_t_tag
        >
      GuidVendorId_t_var;

    typedef
      GuidVendorId_t
      GuidVendorId_t_out;

    typedef
      TAO_Array_Forany_T<
          GuidVendorId_t,
          GuidVendorId_t_slice,
          GuidVendorId_t_tag
        >
      GuidVendorId_t_forany;

    TAO_NAMESPACE_STORAGE_CLASS GuidVendorId_t_slice *
    GuidVendorId_t_alloc (void);

    TAO_NAMESPACE_STORAGE_CLASS void
    GuidVendorId_t_free (
        GuidVendorId_t_slice *_tao_slice);
    
    TAO_NAMESPACE_STORAGE_CLASS GuidVendorId_t_slice *
    GuidVendorId_t_dup (
        const GuidVendorId_t_slice *_tao_slice);
    
    TAO_NAMESPACE_STORAGE_CLASS void
    GuidVendorId_t_copy (
        GuidVendorId_t_slice *_tao_to,
        const GuidVendorId_t_slice *_tao_from);

    // TAO_IDL - Generated from
    // be/be_visitor_array/array_ch.cpp:54

    typedef ::CORBA::Octet GuidPrefix_t[12];
    typedef ::CORBA::Octet GuidPrefix_t_slice;
    struct GuidPrefix_t_tag {};
    

    typedef
      TAO_FixedArray_Var_T<
          GuidPrefix_t,
          GuidPrefix_t_slice,
          GuidPrefix_t_tag
        >
      GuidPrefix_t_var;

    typedef
      GuidPrefix_t
      GuidPrefix_t_out;

    typedef
      TAO_Array_Forany_T<
          GuidPrefix_t,
          GuidPrefix_t_slice,
          GuidPrefix_t_tag
        >
      GuidPrefix_t_forany;

    TAO_NAMESPACE_STORAGE_CLASS GuidPrefix_t_slice *
    GuidPrefix_t_alloc (void);

    TAO_NAMESPACE_STORAGE_CLASS void
    GuidPrefix_t_free (
        GuidPrefix_t_slice *_tao_slice);
    
    TAO_NAMESPACE_STORAGE_CLASS GuidPrefix_t_slice *
    GuidPrefix_t_dup (
        const GuidPrefix_t_slice *_tao_slice);
    
    TAO_NAMESPACE_STORAGE_CLASS void
    GuidPrefix_t_copy (
        GuidPrefix_t_slice *_tao_to,
        const GuidPrefix_t_slice *_tao_from);

    // TAO_IDL - Generated from
    // be/be_visitor_array/array_ch.cpp:54

    typedef ::CORBA::Octet EntityKey_t[3];
    typedef ::CORBA::Octet EntityKey_t_slice;
    struct EntityKey_t_tag {};
    

    typedef
      TAO_FixedArray_Var_T<
          EntityKey_t,
          EntityKey_t_slice,
          EntityKey_t_tag
        >
      EntityKey_t_var;

    typedef
      EntityKey_t
      EntityKey_t_out;

    typedef
      TAO_Array_Forany_T<
          EntityKey_t,
          EntityKey_t_slice,
          EntityKey_t_tag
        >
      EntityKey_t_forany;

    TAO_NAMESPACE_STORAGE_CLASS EntityKey_t_slice *
    EntityKey_t_alloc (void);

    TAO_NAMESPACE_STORAGE_CLASS void
    EntityKey_t_free (
        EntityKey_t_slice *_tao_slice);
    
    TAO_NAMESPACE_STORAGE_CLASS EntityKey_t_slice *
    EntityKey_t_dup (
        const EntityKey_t_slice *_tao_slice);
    
    TAO_NAMESPACE_STORAGE_CLASS void
    EntityKey_t_copy (
        EntityKey_t_slice *_tao_to,
        const EntityKey_t_slice *_tao_from);

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct EntityId_t;

    typedef
      ::TAO_Fixed_Var_T<
          EntityId_t
        >
      EntityId_t_var;

    typedef
      EntityId_t &
      EntityId_t_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_Dcps_Export EntityId_t
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef EntityId_t_var _var_type;
      typedef EntityId_t_out _out_type;
      
      OpenDDS::DCPS::EntityKey_t entityKey;
      ::CORBA::Octet entityKind;
    };

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_BUILTIN_UNKNOWN = 192;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_BUILTIN_PARTICIPANT = 193;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_BUILTIN_WRITER_WITH_KEY = 194;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_BUILTIN_WRITER_NO_KEY = 195;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_BUILTIN_READER_NO_KEY = 196;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_BUILTIN_READER_WITH_KEY = 199;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_BUILTIN_TOPIC = 197;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_USER_UNKNOWN = 0;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_USER_WRITER_WITH_KEY = 2;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_USER_WRITER_NO_KEY = 3;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_USER_READER_NO_KEY = 4;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_USER_READER_WITH_KEY = 7;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_OPENDDS_SUBSCRIBER = 65;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_OPENDDS_PUBLISHER = 66;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_OPENDDS_TOPIC = 69;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_OPENDDS_USER = 74;

    // TAO_IDL - Generated from
    // be/be_visitor_constant/constant_ch.cpp:38

    const CORBA::Octet ENTITYKIND_OPENDDS_NIL_WRITER = 78;

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct GUID_t;

    typedef
      ::TAO_Fixed_Var_T<
          GUID_t
        >
      GUID_t_var;

    typedef
      GUID_t &
      GUID_t_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_Dcps_Export GUID_t
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef GUID_t_var _var_type;
      typedef GUID_t_out _out_type;
      
      OpenDDS::DCPS::GuidPrefix_t guidPrefix;
      OpenDDS::DCPS::EntityId_t entityId;
    };

    // TAO_IDL - Generated from
    // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_OPENDDS_DCPS_GUIDSEQ_CH_)
#define _OPENDDS_DCPS_GUIDSEQ_CH_

    class GUIDSeq;

    typedef
      ::TAO_FixedSeq_Var_T<
          GUIDSeq
        >
      GUIDSeq_var;

    typedef
      ::TAO_Seq_Out_T<
          GUIDSeq
        >
      GUIDSeq_out;

    class OpenDDS_Dcps_Export GUIDSeq
      : public
          ::TAO::unbounded_value_sequence<
              GUID_t
            >
    {
    public:
      GUIDSeq (void);
      GUIDSeq ( ::CORBA::ULong max);
      GUIDSeq (
        ::CORBA::ULong max,
        ::CORBA::ULong length,
        GUID_t* buffer,
        ::CORBA::Boolean release = false);
      GUIDSeq (const GUIDSeq &);
      virtual ~GUIDSeq (void);
      

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef GUIDSeq_var _var_type;
      typedef GUIDSeq_out _out_type;
    };

#endif /* end #if !defined */
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:67
  
  } // module OpenDDS::DCPS

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module OpenDDS

// TAO_IDL - Generated from
// be/be_visitor_arg_traits.cpp:68


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// Arg traits specializations.
namespace TAO
{

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::GuidVendorId_t_tag>
    : public
        Fixed_Array_Arg_Traits_T<
            ::OpenDDS::DCPS::GuidVendorId_t_var,
            ::OpenDDS::DCPS::GuidVendorId_t_forany,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::GuidPrefix_t_tag>
    : public
        Fixed_Array_Arg_Traits_T<
            ::OpenDDS::DCPS::GuidPrefix_t_var,
            ::OpenDDS::DCPS::GuidPrefix_t_forany,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::EntityKey_t_tag>
    : public
        Fixed_Array_Arg_Traits_T<
            ::OpenDDS::DCPS::EntityKey_t_var,
            ::OpenDDS::DCPS::EntityKey_t_forany,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::EntityId_t>
    : public
        Fixed_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::EntityId_t,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::GUID_t>
    : public
        Fixed_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::GUID_t,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::OpenDDS::DCPS::GUIDSeq>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::DCPS::GUIDSeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };
}

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_traits.cpp:62


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

// Traits specializations.
namespace TAO
{
  template<>
  struct OpenDDS_Dcps_Export Array_Traits<
      OpenDDS::DCPS::GuidVendorId_t_forany
    >
  {
    static void free (
        OpenDDS::DCPS::GuidVendorId_t_slice * _tao_slice);
    static OpenDDS::DCPS::GuidVendorId_t_slice * dup (
        const OpenDDS::DCPS::GuidVendorId_t_slice * _tao_slice);
    static void copy (
        OpenDDS::DCPS::GuidVendorId_t_slice * _tao_to,
        const OpenDDS::DCPS::GuidVendorId_t_slice * _tao_from);
    static OpenDDS::DCPS::GuidVendorId_t_slice * alloc (void);
    static void zero (
        OpenDDS::DCPS::GuidVendorId_t_slice * _tao_slice);
  };
  template<>
  struct OpenDDS_Dcps_Export Array_Traits<
      OpenDDS::DCPS::GuidPrefix_t_forany
    >
  {
    static void free (
        OpenDDS::DCPS::GuidPrefix_t_slice * _tao_slice);
    static OpenDDS::DCPS::GuidPrefix_t_slice * dup (
        const OpenDDS::DCPS::GuidPrefix_t_slice * _tao_slice);
    static void copy (
        OpenDDS::DCPS::GuidPrefix_t_slice * _tao_to,
        const OpenDDS::DCPS::GuidPrefix_t_slice * _tao_from);
    static OpenDDS::DCPS::GuidPrefix_t_slice * alloc (void);
    static void zero (
        OpenDDS::DCPS::GuidPrefix_t_slice * _tao_slice);
  };
  template<>
  struct OpenDDS_Dcps_Export Array_Traits<
      OpenDDS::DCPS::EntityKey_t_forany
    >
  {
    static void free (
        OpenDDS::DCPS::EntityKey_t_slice * _tao_slice);
    static OpenDDS::DCPS::EntityKey_t_slice * dup (
        const OpenDDS::DCPS::EntityKey_t_slice * _tao_slice);
    static void copy (
        OpenDDS::DCPS::EntityKey_t_slice * _tao_to,
        const OpenDDS::DCPS::EntityKey_t_slice * _tao_from);
    static OpenDDS::DCPS::EntityKey_t_slice * alloc (void);
    static void zero (
        OpenDDS::DCPS::EntityKey_t_slice * _tao_slice);
  };
}
TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_array/cdr_op_ch.cpp:102



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export CORBA::Boolean operator<< (TAO_OutputCDR &strm, const OpenDDS::DCPS::GuidVendorId_t_forany &_tao_array);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::GuidVendorId_t_forany &_tao_array);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_array/cdr_op_ch.cpp:102



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export CORBA::Boolean operator<< (TAO_OutputCDR &strm, const OpenDDS::DCPS::GuidPrefix_t_forany &_tao_array);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::GuidPrefix_t_forany &_tao_array);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_array/cdr_op_ch.cpp:102



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export CORBA::Boolean operator<< (TAO_OutputCDR &strm, const OpenDDS::DCPS::EntityKey_t_forany &_tao_array);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::EntityKey_t_forany &_tao_array);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::EntityId_t &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::EntityId_t &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::DCPS::GUID_t &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::DCPS::GUID_t &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_OpenDDS_DCPS_GUIDSeq_H_
#define _TAO_CDR_OP_OpenDDS_DCPS_GUIDSeq_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const OpenDDS::DCPS::GUIDSeq &_tao_sequence);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    OpenDDS::DCPS::GUIDSeq &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_OpenDDS_DCPS_GUIDSeq_H_ */

// TAO_IDL - Generated from
// be/be_codegen.cpp:1703


OPENDDS_END_VERSIONED_NAMESPACE_DECL

#if defined (__ACE_INLINE__)
#include "DdsDcpsGuidC.inl"
#endif /* defined INLINE */

#include /**/ "ace/post.h"

#endif /* ifndef */

